

#include <kmpgStandAlone.h>

// YAF include file
#include <devices/audioDeviceLinux.h>

#include "channelWidget.h"
#include "channelDevice.h"


// KDE include files
#include <kapp.h>


#include <unistd.h>




int main(int nargs,char** args) {
  KApplication a( nargs, args, "kmpg" );
  KmpgRootWindow* rootWindow;
  KmpgPlayer* player;
  ChannelDevice* channelDevice=new ChannelDevice();
  ChannelWidget* channelWidget=new ChannelWidget();
  AudioDeviceLinux* audioDevice=new AudioDeviceLinux("/dev/dsp",true);

  rootWindow=KmpgStandAlone::create(_MP3_DECODER);
  player=rootWindow->getPlayer();

  audioDevice->openDevice();
  QObject::connect(channelWidget,SIGNAL(selected(int)),
		   channelDevice,SLOT(setChannel(int)));


  player->addListener(channelDevice);
  player->addListener(audioDevice);
  
  
  channelWidget->setGeometry(200,250,80,80);
  channelWidget->show();
  rootWindow->show();
  a.exec();

  delete channelWidget;
  delete channelDevice;
  return 0;
}
