/*
  device forwards data in realtime (trys to do so)
  Copyright (C) 1998  Martin Vogt

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */





#ifndef _REALTIMEAUDIODEVICE_H
#define _REALTIMEAUDIODEVICE_H


extern "C" {
#include <pthread.h>
#include <unistd.h>
	   }


#include <devices/outputDevice.h>
#include <devices/audioDevice.h>

#include <util/ringBuffer.h>

/**
   Note:

   realTimeDevice don't call the OutputDevice::writeIn() method
   and thus never can be stopped with the delivermode() method
   in OutputDevice!

*/

class RealTimeAudioDevice : public OutputDevice  {

  RingBuffer* ringBuffer;
  int isShutdown;
  int pSize;
  AudioDevice* device;
  int minDeviceBuffer;
  int totalBufferSize;
  pthread_t tr;

  pthread_mutex_t mut;

 public:
  
  RealTimeAudioDevice(AudioDevice* device);
  ~RealTimeAudioDevice();
  char* getNodeName();

  
  int openDevice();
  int closeDevice();
  int getPreferredBufferSize();
  void writeIn(NodeDevice* source,DeviceConfig* buf);

  void readloop();
  void flush();

 private:
  void start();
  void stop();

    
};

#endif




