/*
  produces data and sends them through the device graph (abstract class)
  Copyright (C) 1998  Martin Vogt

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */


#ifndef __STREAMPRODUCER_H
#define __STREAMPRODUCER_H


#include <devices/outputDevice.h>
#include <graph/daisyChain.h>
#include <pthread.h>


class StreamProducer : public OutputDevice {

 public:
  StreamProducer();
  ~StreamProducer();

  // this mut is locked when the thread is active
  void writeOutLock();
  void writeOutUnlock();

  void incBlockCounter();
  void decBlockCounter();
  void waitForUnblock();

 protected:
  pthread_t tr;
  
  pthread_cond_t deliverCond;
  pthread_mutex_t deliverMut;
  
  pthread_mutex_t changeMut;

  pthread_mutex_t counterMut;
  pthread_cond_t counterCond;
  int nBlockCounter;


};


#endif
